<?php

/**
 * Creates field collections in code.
 *
 * @code
 * $menu = CINC::init('FieldCollection')->set('menu_name', 'my_menu')->set('bundle', 'my_content_type');
 * @endcode
 */
class CINC_FieldCollection extends CINC implements CINC_CRUD {

  function __construct() {

    $this->config_filters['field_name'] = 'set_field_name';

  	$this->config = array(
      'field_name' => '',
      'bundle' => '',
      'fields' => array(),
      'entity_type' => 'node',
      'fields' => array(
        'field_name' => '',
      ),
		);

  }

  /**
   * Cleans field name and auto-sets fields[field_name].
   */
  public function set_field_name($field_name) {
    $clean =CINC::clean_machine_name($field_name);
    $this->set('fields', array(
      'field_name' => $clean
    ));
    return $clean;
  }

  /**
   * Saves field collection to the database.
   */
  public function create() {
    $field_collection = entity_create('field_collection_item', $this->config['fields']);
    $field_collection->setHostEntity($this->config['entity_type'], $this->config['bundle']);
    $field_collection->save();

    return $this;
  }

  /**
   * Loads field collection from the database.
   */
  public function read() {
    return $this;
  }

  /**
   * Saves field collection to the database and migrates previous data if machine name changed.
   */
  public function update() {
    $this->create();
    return $this;
  }

  /**
   * Removes field collection from the database.
   */
  public function delete() {
    return $this;
  }

}
